'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _isString2 = require('lodash/isString');

var _isString3 = _interopRequireDefault(_isString2);

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _effects = require('redux-saga/effects');

var _reduxSaga = require('redux-saga');

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

var _websocket = require('./websocket');

var _websocket2 = _interopRequireDefault(_websocket);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CHANNEL_UPDATE = 'UPDATE';
var CHANNEL_DELETE = 'DELETE';
// const SOCKET_AUTH = 'AUTH';

var SOCKET_OPEN = 0;
var SOCKET_MESSAGE = 1;
var SOCKET_PING = 2;
var SOCKET_CLOSE = 3;

var messageInState = function messageInState(state, uri) {
    return state.getIn(['socketReducer', uri]);
};

var ReduxSocket = function () {
    function ReduxSocket(options) {
        _classCallCheck(this, ReduxSocket);

        (0, _invariant2.default)((typeof options === 'undefined' ? 'undefined' : _typeof(options)) === 'object', 'options should be a valid plain Object');
        /* TODO: check url*/
        (0, _invariant2.default)(options.url, 'url should be a valid ws String');

        this.url = options.url;
        this.encode = options.encode;
        this.decode = options.decode;
        this.binaryType = options.binaryType;
        this.reconnectionInterval = options.reconnectionInterval || 60 * 1000;
        this.socket = null;
        this.socketEventChannel = null;
        this.createSocketTime = 0;
        this.lastPingTime = 0;
        this.dispatchChannel = null;
        this.pingChannel = null;
        this.channelMap = {};
        this.handleChannelEventTask = null;
        this.requestStr = options.requestStr || 'data';
        this.responseStr = options.responseStr || 'data';

        this.createSocket = this.createSocket.bind(this);
        this.createChannel = this.createChannel.bind(this);
        this.closeChannel = this.closeChannel.bind(this);
        this.dispatchRequest = this.dispatchRequest.bind(this);
        this.handleChannelEvent = this.handleChannelEvent.bind(this);
        this.createSocketChannel = this.createSocketChannel.bind(this);
        this.pingSaga = this.pingSaga.bind(this);
    }

    _createClass(ReduxSocket, [{
        key: 'createChannel',
        value: _regenerator2.default.mark(function createChannel(_ref) {
            var payload = _ref.payload;
            var action;
            return _regenerator2.default.wrap(function createChannel$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                        case 0:
                            (0, _invariant2.default)((0, _isString3.default)(payload.uri), 'channel uri should be String');

                            if (!(this.socket === null)) {
                                _context.next = 4;
                                break;
                            }

                            _context.next = 4;
                            return (0, _effects.call)(this.createSocket);

                        case 4:
                            action = {
                                opt: CHANNEL_UPDATE,
                                uri: payload.uri
                            };

                            action[this.requestStr] = payload.data;
                            _context.next = 8;
                            return (0, _effects.put)(this.dispatchChannel, action);

                        case 8:
                        case 'end':
                            return _context.stop();
                    }
                }
            }, createChannel, this);
        })
    }, {
        key: 'closeChannel',
        value: _regenerator2.default.mark(function closeChannel(_ref2) {
            var payload = _ref2.payload;
            var action;
            return _regenerator2.default.wrap(function closeChannel$(_context2) {
                while (1) {
                    switch (_context2.prev = _context2.next) {
                        case 0:
                            (0, _invariant2.default)((0, _isString3.default)(payload.uri), 'channel uri should be String');
                            action = {
                                opt: CHANNEL_DELETE,
                                uri: payload.uri
                            };

                            action[this.requestStr] = payload.data;
                            _context2.next = 5;
                            return (0, _effects.put)(this.dispatchChannel, action);

                        case 5:
                        case 'end':
                            return _context2.stop();
                    }
                }
            }, closeChannel, this);
        })
    }, {
        key: 'createPingEvent',
        value: function createPingEvent(secs) {
            // eslint-disable-line
            return (0, _reduxSaga.eventChannel)(function (emitter) {
                var iv = setInterval(function () {
                    emitter('');
                }, secs);
                return function () {
                    clearInterval(iv);
                };
            });
        }
    }, {
        key: 'pingSaga',
        value: _regenerator2.default.mark(function pingSaga() {
            return _regenerator2.default.wrap(function pingSaga$(_context3) {
                while (1) {
                    switch (_context3.prev = _context3.next) {
                        case 0:
                            _context3.next = 2;
                            return (0, _effects.call)(this.createPingEvent, this.reconnectionInterval);

                        case 2:
                            this.pingChannel = _context3.sent;

                        case 3:
                            if (!true) {
                                _context3.next = 19;
                                break;
                            }

                            _context3.next = 6;
                            return (0, _effects.take)(this.pingChannel);

                        case 6:
                            if (!(new Date().getTime() - this.lastPingTime > this.reconnectionInterval * 4)) {
                                _context3.next = 10;
                                break;
                            }

                            if (this.socket !== null) {
                                this.socket.close();
                            }
                            _context3.next = 10;
                            return (0, _effects.call)(this.createSocket);

                        case 10:
                            if (!(this.socket.readyState === 1)) {
                                _context3.next = 14;
                                break;
                            }

                            this.socket.Send('PING');
                            _context3.next = 17;
                            break;

                        case 14:
                            if (!(this.socket.readyState === 2 || this.socket.readyState === 3)) {
                                _context3.next = 17;
                                break;
                            }

                            _context3.next = 17;
                            return (0, _effects.call)(this.createSocket);

                        case 17:
                            _context3.next = 3;
                            break;

                        case 19:
                        case 'end':
                            return _context3.stop();
                    }
                }
            }, pingSaga, this);
        })
    }, {
        key: 'createSocket',
        value: _regenerator2.default.mark(function createSocket() {
            var curTime, _createSocketChannel, socketEventChannel, socket;

            return _regenerator2.default.wrap(function createSocket$(_context4) {
                while (1) {
                    switch (_context4.prev = _context4.next) {
                        case 0:
                            curTime = new Date().getTime();

                            if (!(curTime - this.createSocketTime <= this.reconnectionInterval)) {
                                _context4.next = 3;
                                break;
                            }

                            return _context4.abrupt('return', -1);

                        case 3:
                            if (!(this.socket && (this.socket.readyState === 0 || this.socket.readyState === 1))) {
                                _context4.next = 5;
                                break;
                            }

                            return _context4.abrupt('return', -1);

                        case 5:
                            this.createSocketTime = curTime;

                            if (!(this.dispatchChannel === null)) {
                                _context4.next = 10;
                                break;
                            }

                            _context4.next = 9;
                            return (0, _effects.call)(_reduxSaga.channel, _reduxSaga.buffers.expanding(20));

                        case 9:
                            this.dispatchChannel = _context4.sent;

                        case 10:
                            if (this.handleChannelEventTask !== null) {
                                this.handleChannelEventTask.cancel();
                                this.handleChannelEventTask = null;
                            }

                            if (!(this.pingChannel === null)) {
                                _context4.next = 15;
                                break;
                            }

                            this.lastPingTime = curTime;
                            _context4.next = 15;
                            return (0, _effects.spawn)(this.pingSaga);

                        case 15:
                            _createSocketChannel = this.createSocketChannel(), socketEventChannel = _createSocketChannel.socketEventChannel, socket = _createSocketChannel.socket;

                            this.socketEventChannel = socketEventChannel;
                            this.socket = socket;
                            _context4.next = 20;
                            return (0, _effects.spawn)(this.handleChannelEvent, socketEventChannel);

                        case 20:
                            this.handleChannelEventTask = _context4.sent;
                            return _context4.abrupt('return', 0);

                        case 22:
                        case 'end':
                            return _context4.stop();
                    }
                }
            }, createSocket, this);
        })
    }, {
        key: 'dispatchRequest',
        value: _regenerator2.default.mark(function dispatchRequest(chan) {
            var _this = this;

            var payloads, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, key, payload;

            return _regenerator2.default.wrap(function dispatchRequest$(_context5) {
                while (1) {
                    switch (_context5.prev = _context5.next) {
                        case 0:
                            _context5.next = 2;
                            return (0, _effects.flush)(chan);

                        case 2:
                            payloads = _context5.sent;

                            payloads.map(function (item) {
                                if (item.opt === CHANNEL_UPDATE) {
                                    _this.channelMap[item.uri] = item;
                                } else {
                                    delete _this.channelMap[item.uri];
                                }
                                return item;
                            });

                            _iteratorNormalCompletion = true;
                            _didIteratorError = false;
                            _iteratorError = undefined;
                            _context5.prev = 7;
                            _iterator = Object.keys(this.channelMap)[Symbol.iterator]();

                        case 9:
                            if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                                _context5.next = 16;
                                break;
                            }

                            key = _step.value;
                            _context5.next = 13;
                            return (0, _effects.put)(chan, this.channelMap[key]);

                        case 13:
                            _iteratorNormalCompletion = true;
                            _context5.next = 9;
                            break;

                        case 16:
                            _context5.next = 22;
                            break;

                        case 18:
                            _context5.prev = 18;
                            _context5.t0 = _context5['catch'](7);
                            _didIteratorError = true;
                            _iteratorError = _context5.t0;

                        case 22:
                            _context5.prev = 22;
                            _context5.prev = 23;

                            if (!_iteratorNormalCompletion && _iterator.return) {
                                _iterator.return();
                            }

                        case 25:
                            _context5.prev = 25;

                            if (!_didIteratorError) {
                                _context5.next = 28;
                                break;
                            }

                            throw _iteratorError;

                        case 28:
                            return _context5.finish(25);

                        case 29:
                            return _context5.finish(22);

                        case 30:
                            if (!true) {
                                _context5.next = 38;
                                break;
                            }

                            _context5.next = 33;
                            return (0, _effects.take)(chan);

                        case 33:
                            payload = _context5.sent;

                            (0, _warning2.default)(!(payload.opt === CHANNEL_DELETE && this.channelMap[payload.uri] === undefined), 'close a unopened socket channel or an already closed socket channel');
                            if (payload.opt === CHANNEL_UPDATE) {
                                this.socket.Send(JSON.stringify(payload));
                                this.channelMap[payload.uri] = payload;
                            } else if (this.channelMap[payload.uri] !== undefined) {
                                /**
                                 * CHANNEL_DELETE
                                 */
                                this.socket.Send(JSON.stringify(payload));
                                delete this.channelMap[payload.uri];
                            }
                            _context5.next = 30;
                            break;

                        case 38:
                        case 'end':
                            return _context5.stop();
                    }
                }
            }, dispatchRequest, this, [[7, 18, 22, 30], [23,, 25, 29]]);
        })
    }, {
        key: 'handleChannelEvent',
        value: _regenerator2.default.mark(function handleChannelEvent(chan) {
            var payload, message, selectData, data;
            return _regenerator2.default.wrap(function handleChannelEvent$(_context6) {
                while (1) {
                    switch (_context6.prev = _context6.next) {
                        case 0:
                            if (!true) {
                                _context6.next = 40;
                                break;
                            }

                            _context6.prev = 1;
                            _context6.next = 4;
                            return (0, _effects.take)(chan);

                        case 4:
                            payload = _context6.sent;

                            if (!(payload.type === SOCKET_OPEN)) {
                                _context6.next = 10;
                                break;
                            }

                            _context6.next = 8;
                            return (0, _effects.fork)(this.dispatchRequest, this.dispatchChannel);

                        case 8:
                            _context6.next = 33;
                            break;

                        case 10:
                            if (!(payload.type === SOCKET_MESSAGE)) {
                                _context6.next = 23;
                                break;
                            }

                            message = JSON.parse(payload.message);

                            if (!message.success) {
                                _context6.next = 20;
                                break;
                            }

                            _context6.next = 15;
                            return (0, _effects.select)(messageInState, message.uri);

                        case 15:
                            selectData = _context6.sent;
                            data = _immutable2.default.fromJS(JSON.parse(message[this.responseStr]));

                            if (_immutable2.default.is(data, selectData)) {
                                _context6.next = 20;
                                break;
                            }

                            _context6.next = 20;
                            return (0, _effects.put)({
                                type: '@@redux-saga-websocket/MESSAGE',
                                payload: {
                                    uri: message.uri,
                                    data: data
                                }
                            });

                        case 20:
                            (0, _warning2.default)(message.success, 'socket return unsuccess message ' + payload);
                            _context6.next = 33;
                            break;

                        case 23:
                            if (!(payload.type === SOCKET_PING)) {
                                _context6.next = 27;
                                break;
                            }

                            this.lastPingTime = new Date().getTime();
                            _context6.next = 33;
                            break;

                        case 27:
                            if (!(payload.type === SOCKET_CLOSE)) {
                                _context6.next = 32;
                                break;
                            }

                            _context6.next = 30;
                            return (0, _effects.spawn)(this.createSocket);

                        case 30:
                            _context6.next = 33;
                            break;

                        case 32:
                            (0, _warning2.default)(false, 'Unexpect Message ' + payload);

                        case 33:
                            _context6.next = 38;
                            break;

                        case 35:
                            _context6.prev = 35;
                            _context6.t0 = _context6['catch'](1);

                            (0, _warning2.default)(false, 'unexpect data from server ' + _context6.t0);

                        case 38:
                            _context6.next = 0;
                            break;

                        case 40:
                        case 'end':
                            return _context6.stop();
                    }
                }
            }, handleChannelEvent, this, [[1, 35]]);
        })
    }, {
        key: 'createSocketChannel',
        value: function createSocketChannel() {
            var socket = (0, _websocket2.default)(this.url, this.decode, this.encode, this.binaryType);
            return {
                socketEventChannel: (0, _reduxSaga.eventChannel)(function (emit) {
                    var packetHandler = function packetHandler(event) {
                        emit(event);
                    };

                    socket.onOpen = function (event) {
                        packetHandler({
                            type: SOCKET_OPEN,
                            message: event
                        });
                    };

                    socket.onMessage = function (event) {
                        if (event === 'PONG') {
                            packetHandler({
                                type: SOCKET_PING
                            });
                        } else {
                            packetHandler({
                                type: SOCKET_MESSAGE,
                                message: event
                            });
                        }
                    };

                    socket.onError = function (event) {
                        (0, _warning2.default)(false, 'socket closed onerror: ' + JSON.stringify(event));
                        packetHandler({
                            type: SOCKET_CLOSE
                        });
                    };

                    socket.onClose = function (event) {
                        (0, _warning2.default)(false, 'socket closed onclose: ' + JSON.stringify(event));
                        packetHandler({
                            type: SOCKET_CLOSE
                        });
                    };
                    var unsubscribe = function unsubscribe() {
                        socket.close();
                    };

                    return unsubscribe;
                }, _reduxSaga.buffers.expanding(100)),
                socket: socket
            };
        }
    }]);

    return ReduxSocket;
}();

exports.default = ReduxSocket;