'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

var _actions = require('./actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function socketReducer() {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _immutable2.default.Map();
    var action = arguments[1];

    if (action.type === _actions.createOrUpdateChannelAction.toString()) {
        return state.set(action.payload.uri, null);
    } else if (action.type === _actions.closeChannelAction.toString()) {
        return state.set(action.payload.uri, null);
    } else if (action.type === '@@redux-saga-websocket/MESSAGE') {
        return state.set(action.payload.uri, action.payload.data);
    }
    return state;
}

exports.default = socketReducer;