'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _isString2 = require('lodash/isString');

var _isString3 = _interopRequireDefault(_isString2);

exports.default = createWebsocket;

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var identify = function identify(x) {
    return x;
};

function createWebsocket(url) {
    var decode = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : identify;
    var encode = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : identify;
    var binaryType = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 'arraybuffer';

    (0, _invariant2.default)(window.WebSocket, 'WebSocket should be Object');

    /* TODO: check url whether a valid websocket url*/
    (0, _invariant2.default)((0, _isString3.default)(url), 'url should be String');

    var websocket = new WebSocket(url);
    websocket.binaryType = binaryType;

    window.onbeforeunload = function () {
        return websocket.close();
    };

    websocket.Send = function (message) {
        (0, _invariant2.default)(typeof encode === 'function', 'encode should be Function');
        websocket.send(encode(message));
    };

    websocket.onerror = function () {
        if (websocket.onError) {
            websocket.onError();
        }
    };

    websocket.onopen = function (event) {
        if (websocket.onOpen) {
            websocket.onOpen(event);
        }
    };

    websocket.onclose = function () {
        if (websocket.onClose) {
            websocket.onClose();
        }
    };

    websocket.onmessage = function (event) {
        (0, _invariant2.default)(typeof decode === 'function', 'decode should be Function');
        websocket.onMessage(decode(event.data));
    };
    return websocket;
}